
class Conjonction(frozenset):
    """ 
        Une conjonction logique.
    """
        
    def __or__(self, autre):
        """ Retourne une conjonction couvrant l'union des
            éléments de la conjonction courante et de ceux
            de ``autre``.
            
            :param autre: une autre conjonction.
        """
        
        elements = list(self)
        elements.extend(autre)
        return Conjonction(elements)
    
    def __repr__(self):
        elements = [str(element) for element in sorted(self)]
        conj = ' & '.join(elements)
        if len(elements) > 1:
            return '({})'.format(conj)
        else:
            return conj