
    
class Disjonction(set):
    """ Une disjonction logique. """
    
    def combiner(self, disjonction):
        """ 
            Combine la disjonction courante avec une autre
            afin d'obtenir une disjonction regroupant, sous
            formes de conjonctions, toutes les combinaisons
            d'éléments appartenant à l'une et à l'autre.
            
            Si ``self`` est (p & q) | (u & v) et ``disjonction``
            est (a & b) | (c & d), le résultat sera
            
            (p & q & a & b) | (p & q & c & d) | (u & v & a & b) | (u & v & c & d)
            
            :param disjonction: une autre disjonction.
            
        """
                
        if len(self) == 0:
            return disjonction
        elif len(disjonction) == 0:
            return self
            
        ret = Disjonction()
        for conj_1 in self:
            for conj_2 in disjonction:
                ret.add(conj_1 | conj_2)
                
        return ret  
 
    def __repr__(self):
        if len(self) == 0:
            return '()'
        elements = [str(element) for element in sorted(self)]
        return ' | '.join(elements)
            